hdu 1505 City Game (动态规划)

City Game

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 4838    Accepted Submission(s): 2071

Problem Description

Bob is a strategy game programming specialist. In his new city building game the gaming environment is as follows: a city is built up by areas, in which there are streets, trees,factories and buildings. There is still some space in the area that is unoccupied.
The strategic task of his game is to win as much rent money from these free spaces. To win rent money you must erect buildings, that can only be rectangular, as long and wide as you can. Bob is trying to find a way to build the biggest possible building in
each area. But he comes across some problems – he is not allowed to destroy already existing buildings, trees, factories and streets in the area he is building in.

Each area has its width and length. The area is divided into a grid of equal square units.The rent paid for each unit on which you‘re building stands is 3$.

Your task is to help Bob solve this problem. The whole city is divided into K areas. Each one of the areas is rectangular and has a different grid size with its own length M and width N.The existing occupied units are marked with the symbol R. The unoccupied
units are marked with the symbol F.

Input

The first line of the input contains an integer K – determining the number of datasets. Next lines contain the area descriptions. One description is defined in the following way: The first line contains two integers-area length M<=1000 and width N<=1000, separated
by a blank space. The next M lines contain N symbols that mark the reserved or free grid units,separated by a blank space. The symbols used are:

R – reserved unit

F – free unit

In the end of each area description there is a separating line.

Output

For each data set in the input print on a separate line, on the standard output, the integer that represents the profit obtained by erecting the largest building in the area encoded by the data set.

Sample Input

2
5 6
R F F F F F
F F F F F F
R R R F F F
F F F F F F
F F F F F F

5 5
R R R R R
R R R R R
R R R R R
R R R R R
R R R R R

Sample Output

45
0

hdu1506的加强版,题意让求“F”组成的一整块矩形的最大面积,可以把同一列的F看成一个单位矩形,高度为H,

按照1506的思路就能求解了。

#include<stdio.h>
#include<iostream>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<algorithm>
#include<vector>
#include<queue>
using namespace std;
#define ll __int64
#define N 1005
const int inf=0x7fffffff;
int h[N][N],a[N][N];
int l[N][N],r[N][N];
int n,m;
int main()
{
    int i,j,t,tt;
    char ch;
    scanf("%d",&tt);
    while(tt--)
    {
        scanf("%d%d",&n,&m);
        memset(h[0],0,sizeof(h[0]));
        for(i=1;i<=n;i++)
        {
            h[i][0]=h[i][m+1]=-1;
            for(j=1;j<=m;j++)
            {
                cin>>ch;
                if(ch=='F')
                {
                    h[i][j]=h[i-1][j]+1;
                    a[i][j]=1;
                }
                else
                    h[i][j]=a[i][j]=0;
            }
        }
        for(i=1;i<=n;i++)
        {
            for(j=1;j<=m;j++)
            {
                l[i][j]=r[i][j]=0;
                if(a[i][j]==0)
                    continue;
                t=j;
                while(h[i][j]<=h[i][t]&&j>0)
                    t--;
                l[i][j]=t+1;
                t=j;
                while(h[i][j]<=h[i][t]&&j<=m)
                    t++;
                r[i][j]=t-1;
            }
        }
        int ans=0;
        for(i=1;i<=n;i++)
        {
            for(j=1;j<=m;j++)
            {
                if(a[i][j])
                {
                    t=(r[i][j]-l[i][j]+1)*h[i][j];
                    ans=max(ans,t);
                }
            }
        }
        printf("%d\n",ans*3);
    }
    return 0;
}
时间: 2024-11-08 15:56:38

hdu 1505 City Game (动态规划)的相关文章

HDU 1505 City Game (hdu1506 dp二维加强版)

F - City Game Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1505 Appoint description: Description Bob is a strategy game programming specialist. In his new city building game the gaming enviro

hdu 1505 City Game 最大矩形面积 单调队列

City Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5106    Accepted Submission(s): 2197 Problem Description Bob is a strategy game programming specialist. In his new city building game t

HDU 1505 City Game(01矩阵 dp)

Problem Description Bob is a strategy game programming specialist. In his new city building game the gaming environment is as follows: a city is built up by areas, in which there are streets, trees,factories and buildings. There is still some space i

HDU - 1505 City Game(dp)

题意:求由R和F组成的矩阵中,最大的由F组成的矩阵面积. 分析: 1.hdu1506http://www.cnblogs.com/tyty-Somnuspoppy/p/7341431.html与此题相似. 2.将矩阵的每行看成1506中的坐标轴分别处理. 3.算出以该行为坐标轴,坐标轴上,每个由F组成的矩形的高度,与1506的区别是,1506中每个矩形高度已知. 4.按照1506的方法分别算出每个矩形最左边和最右边连续比其高的矩形的下标,通过(r[i][j] - l[i][j] + 1) * h

hdu 1505 City Game (hdu1506加强版)

# include <stdio.h> # include <algorithm> # include <string.h> # include <iostream> using namespace std; char a[1010][1010]; int dd[1010][1010];///宽度 int r[1010],l[1010]; int main() { int t,i,j,n,m,max1; while(~scanf("%d"

HDU 1505 City Game

题意就是求最大子矩阵. 白书上的例题. 如果暴力枚举 左上角,然后长和宽.时间复杂度为O(m^3*n^3). 可以定义up[][] 为某个格子最大高度, 定义 left[][]为某个格子左扫描最大. 定义 right[][]为右扫描的最大. 最后乘起来. #include<cstdio> #include<cstring> #include<string> #include<queue> #include<algorithm> #include&

hdu 1505 City Game(hdu1506的二维推广)

1.输入的时候数据的时候要注意 2.1506的二维推广 代码: #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int INF=1<<30; int a[1005][1005]; int L[1005]; int R[1005]; int main() { int t; int m,n; int ans; char s[10]; scanf(&

HDU 1505 City Game【DP】

题意:是二维的1506,即在1506的基础上,再加一个for循环,即从第一行到最后一行再扫一遍--- 自己写的时候,输入的方法不对---发现输不出结果,后来看了别人的[email protected][email protected]发现是将字母和空格当成一个字符串来输入的. #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace st

HDU 1505 City Game-dp-(最大子矩阵模型)

题意:求最大的子矩阵 分析:直接用最大字矩阵的公式做超时了.换个思路,这题跟上一题1506有关系,先以每层为底算出每个元素能到达的最大的高度,然后就跟1506一样了.这里求高度和求面积两处地方用到了dp暂存数据.求高度用二重循环,然后每层为底求面积要二重循环加上外层就是三重循环,但是由于用了dp保存中间结果,所以这个三重循环不会超时.dp[j]表示当前层第j列能到达的最大的高度,状态转移:1.a[i][j]=='R'时,dp[j]=0:2.否则,若a[i-1][j]=='F',则dp[j]++(